//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu> (from 18Dec1997)
// Creation Date: 26 December 1997
// Last Modified: 26 December 1997
// Filename:      ...sig/code/control/misc/notenames.h
// Web Address:   http://www-ccrma.stanford.edu/~craig/improv/include/notenames.h
// Syntax:        C
//
// Description:   Defines for pitch names of midi key numbers 
//

#ifndef _NOTENAMES_H_INCLUDED
#define _NOTENAMES_H_INCLUDED

#define  C00    (0)
#define  Cs00   (1)
#define  Db00   (1)
#define  D00    (2)
#define  Ds00   (3)
#define  Eb00   (3)
#define  E00    (4)
#define  F00    (5)
#define  Fs00   (6)
#define  Gb00   (6)
#define  G00    (7)
#define  Gs00   (8)
#define  Ab00   (8)
#define  A00    (9)
#define  As00   (10)
#define  Bb00   (10)
#define  B00    (11)

#define  C0     (12)
#define  Cs0    (13)
#define  Db0    (13)
#define  D0     (14)
#define  Ds0    (15)
#define  Eb0    (15)
#define  E0     (16)
#define  F0     (17)
#define  Fs0    (18)
#define  Gb0    (18)
#define  G0     (19)
#define  Gs0    (20)
#define  Ab0    (20)
#define  A0     (21)
#define  As0    (22)
#define  Bb0    (22)

/* 
 * Note that the following symbol B0 is used in
 * unix in the file /usr/include/termios.h also as
 * a symbol, so It is disabled for now in this file.
 * termios.h is need in Unix for the KeyboardInput.h file
 */

// #define  B0     (23)

#define  C1     (24)
#define  Cs1    (25)
#define  Db1    (25)
#define  D1     (26)
#define  Ds1    (27)
#define  Eb1    (27)
#define  E1     (28)
#define  F1     (29)
#define  Fs1    (30)
#define  Gb1    (30)
#define  G1     (31)
#define  Gs1    (32)
#define  Ab1    (32)
#define  A1     (33)
#define  As1    (34)
#define  Bb1    (34)
#define  B1     (35)

#define  C2     (36)
#define  Cs2    (37)
#define  Db2    (37)
#define  D2     (38)
#define  Ds2    (39)
#define  Eb2    (39)
#define  E2     (40)
#define  F2     (41)
#define  Fs2    (42)
#define  Gb2    (42)
#define  G2     (43)
#define  Gs2    (44)
#define  Ab2    (44)
#define  A2     (45)
#define  As2    (46)
#define  Bb2    (46)
#define  B2     (47)

#define  C3     (48)
#define  Cs3    (49)
#define  Db3    (49)
#define  D3     (50)
#define  Ds3    (51)
#define  Eb3    (51)
#define  E3     (52)
#define  F3     (53)
#define  Fs3    (54)
#define  Gb3    (54)
#define  G3     (55)
#define  Gs3    (56)
#define  Ab3    (56)
#define  A3     (57)
#define  As3    (58)
#define  Bb3    (58)
#define  B3     (59)

#define  C4     (60)
#define  Cs4    (61)
#define  Db4    (61)
#define  D4     (62)
#define  Ds4    (63)
#define  Eb4    (63)
#define  E4     (64)
#define  F4     (65)
#define  Fs4    (66)
#define  Gb4    (66)
#define  G4     (67)
#define  Gs4    (68)
#define  Ab4    (68)
#define  A4     (69)
#define  As4    (70)
#define  Bb4    (70)
#define  B4     (71)

#define  C5     (72)
#define  Cs5    (73)
#define  Db5    (73)
#define  D5     (74)
#define  Ds5    (75)
#define  Eb5    (75)
#define  E5     (76)
#define  F5     (77)
#define  Fs5    (78)
#define  Gb5    (78)
#define  G5     (79)
#define  Gs5    (80)
#define  Ab5    (81)
#define  A5     (81)
#define  As5    (82)
#define  Bb5    (82)
#define  B5     (83)

#define  C6     (84)
#define  Cs6    (85)
#define  Db6    (85)
#define  D6     (86)
#define  Ds6    (87)
#define  Eb6    (87)
#define  E6     (88)
#define  F6     (89)
#define  Fs6    (90)
#define  Gb6    (90)
#define  G6     (91)
#define  Gs6    (92)
#define  Ab6    (92)
#define  A6     (93)
#define  As6    (94)
#define  Bb6    (94)
#define  B6     (95)

#define  C7     (96)
#define  Cs7    (97)
#define  Db7    (97)
#define  D7     (98)
#define  Ds7    (99)
#define  Eb7    (99)
#define  E7     (100)
#define  F7     (101)
#define  Fs7    (102)
#define  Gb7    (102)
#define  G7     (103)
#define  Gs7    (104)
#define  Ab7    (104)
#define  A7     (105)
#define  As7    (106)
#define  Bb7    (106)
#define  B7     (107)

#define  C8     (108)
#define  Cs8    (109)
#define  Db8    (109)
#define  D8     (110)
#define  Ds8    (111)
#define  Eb8    (111)
#define  E8     (112)
#define  F8     (113)
#define  Fs8    (114)
#define  Gb8    (114)
#define  G8     (115)
#define  Gs8    (116)
#define  Ab8    (116)
#define  A8     (117)
#define  As8    (118)
#define  Bb8    (118)
#define  B8     (119)

#define  C9     (120)
#define  Cs9    (121)
#define  Db9    (121)
#define  D9     (122)
#define  Ds9    (123)
#define  Eb9    (123)
#define  E9     (124)
#define  F9     (125)
#define  Fs9    (126)
#define  Gb9    (126)
#define  G9     (127)


#endif  /* _NOTENAMES_H_INCLUDED */


// md5sum:	c0f727163d32e04212a0ce5c8b6c4a6f  - notenames.h =css= 20030102
